/// @cond EO_CXX_EO_IMPL

inline void elm::photo::thumb_set(::efl::eina::optional< ::efl::eina::string_view > file_, ::efl::eina::optional< ::efl::eina::string_view > group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_thumb_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(group_)));
}

inline bool elm::photo::editable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_editable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::photo::editable_set(bool set_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_editable_set(::efl::eolian::to_c(set_)));
}

inline bool elm::photo::fill_inside_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_fill_inside_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::photo::fill_inside_set(bool fill_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_fill_inside_set(::efl::eolian::to_c(fill_)));
}

inline bool elm::photo::aspect_fixed_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_aspect_fixed_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::photo::aspect_fixed_set(bool fixed_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_aspect_fixed_set(::efl::eolian::to_c(fixed_)));
}

inline int elm::photo::size_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_size_get());
   return _tmp_ret;
}

inline void elm::photo::size_set(int size_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_size_set(size_));
}

inline void eo_cxx::elm::photo::thumb_set(::efl::eina::optional< ::efl::eina::string_view > file_, ::efl::eina::optional< ::efl::eina::string_view > group_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_thumb_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(group_)));
}

inline bool eo_cxx::elm::photo::editable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_editable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::photo::editable_set(bool set_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_editable_set(::efl::eolian::to_c(set_)));
}

inline bool eo_cxx::elm::photo::fill_inside_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_fill_inside_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::photo::fill_inside_set(bool fill_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_fill_inside_set(::efl::eolian::to_c(fill_)));
}

inline bool eo_cxx::elm::photo::aspect_fixed_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_aspect_fixed_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::photo::aspect_fixed_set(bool fixed_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_aspect_fixed_set(::efl::eolian::to_c(fixed_)));
}

inline int eo_cxx::elm::photo::size_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_photo_size_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::photo::size_set(int size_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_photo_size_set(size_));
}

inline ::eo_cxx::elm::photo::operator ::elm::photo() const
{
   return *static_cast<::elm::photo const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::photo::operator ::elm::photo&()
{
   return *static_cast<::elm::photo*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::photo::operator ::elm::photo const&() const
{
   return *static_cast<::elm::photo const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_photo_thumb_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * file_, const char * group_)
{
   try
      {
         static_cast<T*>(self->this_)->thumb_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(file_, std::tuple<std::false_type>()), ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(group_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_photo_editable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->editable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_photo_editable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool set_)
{
   try
      {
         static_cast<T*>(self->this_)->editable_set(::efl::eolian::to_cxx<bool>(set_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_photo_fill_inside_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->fill_inside_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_photo_fill_inside_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool fill_)
{
   try
      {
         static_cast<T*>(self->this_)->fill_inside_set(::efl::eolian::to_cxx<bool>(fill_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_photo_aspect_fixed_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->aspect_fixed_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_photo_aspect_fixed_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool fixed_)
{
   try
      {
         static_cast<T*>(self->this_)->aspect_fixed_set(::efl::eolian::to_cxx<bool>(fixed_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
int elm_photo_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->size_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_photo_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int size_)
{
   try
      {
         static_cast<T*>(self->this_)->size_set(size_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::photo >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
         , virtual operations< ::efl::file >::template type<T>
         , virtual operations< ::evas::clickable_interface >::template type<T>
         , virtual operations< ::evas::draggable_interface >::template type<T>
   {
      virtual void thumb_set(::efl::eina::optional< ::efl::eina::string_view > file_, ::efl::eina::optional< ::efl::eina::string_view > group_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_photo_thumb_set(::efl::eolian::to_c(file_), ::efl::eolian::to_c(group_)));
      }

      virtual bool editable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photo_editable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void editable_set(bool set_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_photo_editable_set(::efl::eolian::to_c(set_)));
      }

      virtual bool fill_inside_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photo_fill_inside_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void fill_inside_set(bool fill_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_photo_fill_inside_set(::efl::eolian::to_c(fill_)));
      }

      virtual bool aspect_fixed_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photo_aspect_fixed_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void aspect_fixed_set(bool fixed_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_photo_aspect_fixed_set(::efl::eolian::to_c(fixed_)));
      }

      virtual int size_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_photo_size_get());
            return _tmp_ret;
      }

      virtual void size_set(int size_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_photo_size_set(size_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::photo >
{
   static constexpr int value = 
#if defined(PHOTO_PROTECTED) && defined(PHOTO_BETA)
      9
#elif defined(PHOTO_PROTECTED)
      9
#elif defined(PHOTO_BETA)
      9
#else
      9
#endif
      + operation_description_class_size<::elm::widget >::value      + operation_description_class_size<::efl::file >::value      + operation_description_class_size<::evas::clickable_interface >::value      + operation_description_class_size<::evas::draggable_interface >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::photo>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_thumb_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_thumb_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_editable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_editable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_editable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_editable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_fill_inside_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_fill_inside_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_fill_inside_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_fill_inside_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_aspect_fixed_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_aspect_fixed_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_aspect_fixed_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_aspect_fixed_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_photo_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_photo_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::photo >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::file>(), &ops[operation_description_class_size< ::elm::photo >::value + operation_description_class_size<::elm::widget>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::clickable_interface>(), &ops[operation_description_class_size< ::elm::photo >::value + operation_description_class_size<::elm::widget>::value + operation_description_class_size<::efl::file>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::evas::draggable_interface>(), &ops[operation_description_class_size< ::elm::photo >::value + operation_description_class_size<::elm::widget>::value + operation_description_class_size<::efl::file>::value + operation_description_class_size<::evas::clickable_interface>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::photo>)
{
   return (ELM_PHOTO_CLASS);
}

} } }

/// @endcond

